/**
 * Generated by Apache Royale Compiler from org/apache/royale/html/beads/DragBead.as
 * org.apache.royale.html.beads.DragBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.html.beads.DragBead');

goog.require('org.apache.royale.core.IChild');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.core.IUIBase');
goog.require('org.apache.royale.events.IEventDispatcher');
goog.require('org.apache.royale.events.MouseEvent');
goog.require('org.apache.royale.events.utils.MouseEventConverter');
goog.require('org.apache.royale.geom.Point');
goog.require('org.apache.royale.geom.Rectangle');
goog.require('org.apache.royale.core.IBead');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.core.IBead}
 */
org.apache.royale.html.beads.DragBead = function() {
};


/**
 * @protected
 * @type {org.apache.royale.core.IUIBase}
 */
org.apache.royale.html.beads.DragBead.prototype._host;


/**
 * @protected
 * @type {org.apache.royale.geom.Point}
 */
org.apache.royale.html.beads.DragBead.prototype.startingPoint;


/**
 * @private
 * @type {org.apache.royale.events.IEventDispatcher}
 */
org.apache.royale.html.beads.DragBead.prototype.org_apache_royale_html_beads_DragBead__hitArea;


/**
 * @private
 * @type {org.apache.royale.geom.Rectangle}
 */
org.apache.royale.html.beads.DragBead.prototype.org_apache_royale_html_beads_DragBead__moveArea;


/**
 * @protected
 * @param {org.apache.royale.events.MouseEvent} event
 */
org.apache.royale.html.beads.DragBead.prototype.mouseDownHandler = function(event) {
  this.startingPoint = new org.apache.royale.geom.Point(event.clientX, event.clientY);
  window.addEventListener(org.apache.royale.events.MouseEvent.MOUSE_MOVE, org.apache.royale.utils.Language.closure(this.mouseMoveHandler, this, 'mouseMoveHandler'));
  window.addEventListener(org.apache.royale.events.MouseEvent.MOUSE_UP, org.apache.royale.utils.Language.closure(this.mouseUpHandler, this, 'mouseUpHandler'));
  
};


/**
 * @protected
 * @param {org.apache.royale.events.MouseEvent} event
 */
org.apache.royale.html.beads.DragBead.prototype.mouseMoveHandler = function(event) {
  event = org.apache.royale.events.utils.MouseEventConverter.convert(event);
  var /** @type {number} */ xDelta = event.clientX - this.startingPoint.x;
  var /** @type {number} */ yDelta = event.clientY - this.startingPoint.y;
  var /** @type {number} */ potentialX = this._host.x + xDelta;
  var /** @type {number} */ potentialY = this._host.y + yDelta;
  if (potentialX < this.org_apache_royale_html_beads_DragBead__moveArea.x || potentialX > this.org_apache_royale_html_beads_DragBead__moveArea.x + this.org_apache_royale_html_beads_DragBead__moveArea.width) {
    xDelta = 0;
  }
  if (potentialY < this.org_apache_royale_html_beads_DragBead__moveArea.y || potentialY > this.org_apache_royale_html_beads_DragBead__moveArea.y + this.org_apache_royale_html_beads_DragBead__moveArea.height) {
    yDelta = 0;
  }
  this._host.x = this._host.x + xDelta;
  this._host.y = this._host.y + yDelta;
  this.startingPoint.x += xDelta;
  this.startingPoint.y += yDelta;
};


/**
 * @protected
 * @param {org.apache.royale.events.MouseEvent} event
 */
org.apache.royale.html.beads.DragBead.prototype.mouseUpHandler = function(event) {
  
  window.removeEventListener(org.apache.royale.events.MouseEvent.MOUSE_MOVE, org.apache.royale.utils.Language.closure(this.mouseMoveHandler, this, 'mouseMoveHandler'));
  window.removeEventListener(org.apache.royale.events.MouseEvent.MOUSE_UP, org.apache.royale.utils.Language.closure(this.mouseUpHandler, this, 'mouseUpHandler'));
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.core.IStrand}
 */
org.apache.royale.html.beads.DragBead.prototype.strand;


org.apache.royale.html.beads.DragBead.prototype.set__strand = function(value) {
  this._host = org.apache.royale.utils.Language.as(value, org.apache.royale.core.IUIBase);
  if (!this.org_apache_royale_html_beads_DragBead__hitArea) {
    this.org_apache_royale_html_beads_DragBead__hitArea = org.apache.royale.utils.Language.as(value, org.apache.royale.events.IEventDispatcher);
  }
  if (!this.org_apache_royale_html_beads_DragBead__moveArea) {
    var /** @type {org.apache.royale.core.IUIBase} */ hostParent = org.apache.royale.utils.Language.as(org.apache.royale.utils.Language.as(this._host, org.apache.royale.core.IChild).parent, org.apache.royale.core.IUIBase);
    this.org_apache_royale_html_beads_DragBead__moveArea = new org.apache.royale.geom.Rectangle(hostParent.x, hostParent.y, hostParent.width, hostParent.height);
  }
  this.org_apache_royale_html_beads_DragBead__hitArea.addEventListener(org.apache.royale.events.MouseEvent.MOUSE_DOWN, org.apache.royale.utils.Language.closure(this.mouseDownHandler, this, 'mouseDownHandler'));
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.events.IEventDispatcher}
 */
org.apache.royale.html.beads.DragBead.prototype.hitArea;


org.apache.royale.html.beads.DragBead.prototype.get__hitArea = function() {
  return this.org_apache_royale_html_beads_DragBead__hitArea;
};


org.apache.royale.html.beads.DragBead.prototype.set__hitArea = function(value) {
  this.org_apache_royale_html_beads_DragBead__hitArea = value;
};


/**
 * @nocollapse
 * @export
 * @type {org.apache.royale.geom.Rectangle}
 */
org.apache.royale.html.beads.DragBead.prototype.moveArea;


org.apache.royale.html.beads.DragBead.prototype.get__moveArea = function() {
  return this.org_apache_royale_html_beads_DragBead__moveArea;
};


org.apache.royale.html.beads.DragBead.prototype.set__moveArea = function(value) {
  this.org_apache_royale_html_beads_DragBead__moveArea = value;
};


Object.defineProperties(org.apache.royale.html.beads.DragBead.prototype, /** @lends {org.apache.royale.html.beads.DragBead.prototype} */ {
/**
 * @type {org.apache.royale.core.IStrand}
 */
strand: {
set: org.apache.royale.html.beads.DragBead.prototype.set__strand},
/**
 * @type {org.apache.royale.events.IEventDispatcher}
 */
hitArea: {
get: org.apache.royale.html.beads.DragBead.prototype.get__hitArea,
set: org.apache.royale.html.beads.DragBead.prototype.set__hitArea},
/**
 * @type {org.apache.royale.geom.Rectangle}
 */
moveArea: {
get: org.apache.royale.html.beads.DragBead.prototype.get__moveArea,
set: org.apache.royale.html.beads.DragBead.prototype.set__moveArea}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.html.beads.DragBead.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'DragBead', qName: 'org.apache.royale.html.beads.DragBead', kind: 'class' }], interfaces: [org.apache.royale.core.IBead] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.html.beads.DragBead.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.html.beads.DragBead'},
        'hitArea': { type: 'org.apache.royale.events.IEventDispatcher', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.DragBead'},
        'moveArea': { type: 'org.apache.royale.geom.Rectangle', access: 'readwrite', declaredBy: 'org.apache.royale.html.beads.DragBead'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.html.beads.DragBead.prototype.ROYALE_COMPILE_FLAGS = 10;