/**
 * Generated by Apache Royale Compiler from org/apache/royale/routing/RouteToParameters.as
 * org.apache.royale.routing.RouteToParameters
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.routing.RouteToParameters');

goog.require('org.apache.royale.core.Bead');
goog.require('org.apache.royale.core.IStrand');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.events.ValueEvent');
goog.require('org.apache.royale.routing.IRouter');
goog.require('org.apache.royale.routing.ParameterRoute');
goog.require('org.apache.royale.routing.RouteState');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @extends {org.apache.royale.core.Bead}
 */
org.apache.royale.routing.RouteToParameters = function() {
  org.apache.royale.routing.RouteToParameters.base(this, 'constructor');
};
goog.inherits(org.apache.royale.routing.RouteToParameters, org.apache.royale.core.Bead);


/**
 * @protected
 * @param {org.apache.royale.events.ValueEvent} event
 */
org.apache.royale.routing.RouteToParameters.prototype.urlNeeded = function(event) {
  var /** @type {string} */ hash = org.apache.royale.utils.Language.string(event.value);
  var /** @type {string} */ paramStr = this.org_apache_royale_routing_RouteToParameters_buildParameterString();
  var /** @type {string} */ trailing = "";
  var /** @type {number} */ index = (hash.indexOf("#")) >> 0;
  if (index != -1) {
    trailing = hash.slice(index);
    hash = hash.slice(0, index);
  }
  event.value = hash + paramStr + trailing;
};


/**
 * @protected
 * @param {org.apache.royale.events.ValueEvent} event
 */
org.apache.royale.routing.RouteToParameters.prototype.urlReceived = function(event) {
  var /** @type {string} */ hash = org.apache.royale.utils.Language.string(event.value);
  var /** @type {number} */ index = (hash.indexOf("?")) >> 0;
  if (index == -1)
    return;
  hash = hash.slice(index + 1);
  index = (hash.indexOf("#")) >> 0;
  if (index != -1) {
    hash = hash.slice(0, index);
  }
  this.org_apache_royale_routing_RouteToParameters_host.routeState.parameters = this.org_apache_royale_routing_RouteToParameters_parseParameters(hash);
};


/**
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.routing.RouteToParameters.prototype.stateChanged = function(event) {
  var /** @type {Object} */ params = this.org_apache_royale_routing_RouteToParameters_host.routeState.parameters;
  if (this.routes) {
    for (var /** @type {number} */ i = 0; i < this.routes.length; i++) {
      var /** @type {org.apache.royale.routing.ParameterRoute} */ route = this.routes[i];
      var /** @type {string} */ value = route.defaultValue;
      if (route.key in params) {
        value = org.apache.royale.utils.Language.string(params[route.key]);
      }
      if (value) {
        route.callback(value);
        if (route.title)
          this.org_apache_royale_routing_RouteToParameters_host.routeState.title = route.title;
      }
    }
  }
};


/**
 * @type {Array}
 */
org.apache.royale.routing.RouteToParameters.prototype.routes;


/**
 * @private
 * @return {string}
 */
org.apache.royale.routing.RouteToParameters.prototype.org_apache_royale_routing_RouteToParameters_buildParameterString = function() {
  var /** @type {string} */ retVal = "";
  var /** @type {org.apache.royale.routing.RouteState} */ state = this.org_apache_royale_routing_RouteToParameters_host.routeState;
  if (state.parameters) {
    retVal += "?";
    for (var /** @type {string} */ x in state.parameters) {
      retVal += x;
      if (state.parameters[x] != undefined) {
        retVal += "=" + encodeURIComponent(org.apache.royale.utils.Language.string(state.parameters[x]));
        retVal += "&";
      }
    }
    retVal = retVal.slice(0, -1);
  }
  return retVal;
};


/**
 * @private
 * @param {string} query
 * @return {Object}
 */
org.apache.royale.routing.RouteToParameters.prototype.org_apache_royale_routing_RouteToParameters_parseParameters = function(query) {
  var /** @type {Object} */ urlVars;
  if (query) {
    var /** @type {Array} */ vars = query.split("&");
    if (vars.length) {
      urlVars = {};
    }
    for (var /** @type {number} */ i = 0; i < vars.length; i++) {
      var /** @type {Array} */ pair = vars[i].split("=");
      urlVars[pair[0]] = pair[1] == undefined ? undefined : decodeURIComponent(org.apache.royale.utils.Language.string(pair[1]));
    }
  }
  return urlVars;
};


/**
 * @type {org.apache.royale.routing.IRouter}
 */
org.apache.royale.routing.RouteToParameters.prototype.org_apache_royale_routing_RouteToParameters_host;


org.apache.royale.routing.RouteToParameters.prototype.get__org_apache_royale_routing_RouteToParameters_host = function() {
  return this._strand;
};


org.apache.royale.routing.RouteToParameters.prototype.set__strand = function(value) {
  this._strand = value;
  this.listenOnStrand("urlNeeded", org.apache.royale.utils.Language.closure(this.urlNeeded, this, 'urlNeeded'));
  this.listenOnStrand("urlReceived", org.apache.royale.utils.Language.closure(this.urlReceived, this, 'urlReceived'));
  this.listenOnStrand("stateChange", org.apache.royale.utils.Language.closure(this.stateChanged, this, 'stateChanged'));
};


Object.defineProperties(org.apache.royale.routing.RouteToParameters.prototype, /** @lends {org.apache.royale.routing.RouteToParameters.prototype} */ {
/**
 * @type {org.apache.royale.routing.IRouter}
 */
org_apache_royale_routing_RouteToParameters_host: {
get: org.apache.royale.routing.RouteToParameters.prototype.get__org_apache_royale_routing_RouteToParameters_host},
/**
 * @type {org.apache.royale.core.IStrand}
 */
strand: {
set: org.apache.royale.routing.RouteToParameters.prototype.set__strand}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.routing.RouteToParameters.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'RouteToParameters', qName: 'org.apache.royale.routing.RouteToParameters', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.routing.RouteToParameters.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'routes': { type: 'Array', get_set: function (/** org.apache.royale.routing.RouteToParameters */ inst, /** * */ v) {return v !== undefined ? inst.routes = v : inst.routes;}}
      };
    },
    accessors: function () {
      return {
        'strand': { type: 'org.apache.royale.core.IStrand', access: 'writeonly', declaredBy: 'org.apache.royale.routing.RouteToParameters'}
      };
    },
    methods: function () {
      return {
        'RouteToParameters': { type: '', declaredBy: 'org.apache.royale.routing.RouteToParameters'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.routing.RouteToParameters.prototype.ROYALE_COMPILE_FLAGS = 10;